<?php

require_once 'config.php';

if (isset($_GET['power']) && isset($_GET['voltage']) && isset($_GET['current']) && isset($_GET['energy']) && isset($_GET['frequency'])) {
    $power = $_GET['power'];
    $voltage = $_GET['voltage'];
    $current = $_GET['current'];
    $energy = $_GET['energy'];
    $frequency = $_GET['frequency'];

    date_default_timezone_set('Europe/Berlin');
    $datetime = date('Y-m-d H:i:s');

    $sqlUpdateLastConnection = "UPDATE settings SET last_connection = '$datetime' WHERE id = 0";
    if ($conn->query($sqlUpdateLastConnection) !== TRUE) {
        echo "[Fehler] Fehler beim Aktualisieren von last_connection: " . $conn->error;
        $conn->close();
        exit;
    }

    $sqlRecordCheck = "SELECT record FROM settings WHERE id = 0 LIMIT 1";
    $resultRecord = $conn->query($sqlRecordCheck);

    if ($resultRecord->num_rows > 0) {
        $recordRow = $resultRecord->fetch_assoc();
        if ($recordRow['record'] != 1) {
            echo "[OK]";
            $conn->close();
            exit;
        }
    } else {
        echo "[Fehler] Konnte den Record-Wert aus der Settings-Tabelle nicht abrufen.";
        $conn->close();
        exit;
    }

    $sqlCheck = "SELECT COUNT(*) AS count FROM data";
    $result = $conn->query($sqlCheck);
    $row = $result->fetch_assoc();

    if ($row['count'] == 0) {
        $sqlUpdateOffset = "UPDATE settings SET offset = '$energy' WHERE id = 0";
        if ($conn->query($sqlUpdateOffset) !== TRUE) {
            echo "[Fehler] Fehler beim Aktualisieren des Offset-Wertes: " . $conn->error;
            $conn->close();
            exit;
        }
    }

    $sqlInsert = "INSERT INTO data (timestamp, power, voltage, current, energy, frequency) 
                  VALUES ('$datetime', '$power', '$voltage', '$current', '$energy', '$frequency')";

    if ($conn->query($sqlInsert) === TRUE) {
        echo "[OK]";
    } else {
        echo "[Fehler] Fehler beim Schreiben in die Datenbank: " . $conn->error;
    }
} else {
    echo "[Fehler] Fehlende Parameter. Bitte alle Parameter (power, voltage, current, energy & frequency) &uuml;bergeben.";
}

$conn->close();
?>
